#include <stdio.h>

#include <qfileinfo.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qtextcodec.h>
#include <qpe/config.h>

#include "flmod.h"
#include "../FileLaunch/Flib.h"

FlMod::FlMod(const char* filename)
{


	QFileInfo fi(filename);
	if (! fi.exists()) {
		printf("%s not resident",filename);
		exit(127);
	}

	QFile f(filename);
	if ( f.open(IO_ReadOnly)) {
		QTextCodec* codec = QTextCodec::codecForName("utf8");
		QTextStream t( &f );
		t.setCodec(codec);
		QString txt = t.read();
		f.close();
		QStringList itemList = getItem(txt);
		modItem(itemList);
	} else {
		printf("%s open error",filename);
		exit(127);
	}
}

FlMod::~FlMod()
{
}

QStringList FlMod::getItem(const QString& txt)
{
	return QStringList::split('\n',txt);
}

void FlMod::modItem(const QStringList& item)
{
	Config cf(ConfigName);
	cf.setGroup("menu");
	int i = 0;
	for ( QStringList::ConstIterator it = item.begin(); it != item.end(); ++it ) {
		int e = (*it).find(QChar('='));
		QString key = (*it).left(e).stripWhiteSpace();
		QStringList data = QStringList::split(',',(*it).mid(e+1));
		QStringList org ;
		org = cf.readListEntry(key,',');
		org[3] = data[3];
		org[4] = data[4];
		org[5] = data[5];
		org[6] = data[6];
		org[7] = data[7];
		org[8] = data[8];
		cf.writeEntry(key,org,',');
		++i;
	}
	printf ("mod %d items \n",i );
}

const char FlMod::ConfigName[] = { "FileLaunch" };
