#include <qwidget.h>
#include <qdialog.h>
#include <qtabwidget.h>
#include <qpopupmenu.h>
#include <qpe/qpemenubar.h>
#include <qlist.h>
#include <qlayout.h>

class QGridLayout; 
class QBoxLayout;
class QLabel;
class QListView;
class QListViewItem;
class QPushButton;
class QTabWidget;
class AppLnkSet;

struct MenuSet {
	QString type;
	QWidget* wid;
	QBoxLayout* lay;
	QListView* list;
};

class AplDialog : public QDialog
{
	Q_OBJECT

public:
	AplDialog(QWidget* parent = 0, const char* name = 0, bool modal = TRUE, WFlags fl = 0 );
	~AplDialog() ;
	QString desktopName();

protected slots:

	virtual void accept () ;

private slots:
	void selectChanged(QListViewItem* i);

private:
	void loadDesktop();
	void loadMenuTab();
	void makeMenuTab(const QIconSet& ic,const QString& s ,const QString& t);


	MenuSet* findTab(QString s);
	AppLnkSet *set;
	QBoxLayout *layout;
	QTabWidget* setTab;
	QList<MenuSet> menuSet;
	QString desktop;

	enum {
		AplName,
		Spacer,
		DesktopFile
	};
};

