#include <qmainwindow.h>
#include <qwidget.h>
#include <qtabwidget.h>
#include <qpopupmenu.h>
#include <qpe/qpemenubar.h>
#include <qmap.h>

#include "../FileLaunch/MenuItem.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QCheckBox;
class QLabel;
class QLineEdit;
class QListView;
class QListViewItem;
class QPushButton;
class QSpinBox;
class QComboBox;
class QTabWidget;
class QString;
class QStringList;
class MListItem;

class FLUtil : public QMainWindow
{
	Q_OBJECT

public:
	FLUtil() ;
	~FLUtil() ;

protected:
	virtual void closeEvent(QCloseEvent *e);

private slots:
	void addClicked();
	void modClicked();
	void delClicked();
	void upClicked();
	void downClicked();
	void levelClicked();
	void listSelected(QListViewItem* );
	void getMemoAlter();
	void optOkClicked();
	void optCancelClicked();
	void setColorTab(int i);
	void setColor();
	void reloadColor();

private:
	void loadCfg();
	void saveCfg();
	void loadPixmap(MListItem* m);
	QString toCfg(MListItem* m);
	void makeConfTab();
	void makeMenuTab();
	void makeOptTab();
	void makeColorTab();
	void setKeyMap(QListViewItem* item);
	void loadOpt();
	void setOpt();
	void setSudo(int i,bool b);

	int viewFontSize;
	int fileFontSize;
	QStringList shellExt;
	QStringList textExt;
	QString memoAlter;
	bool useSudo;
	bool symmetry;
	bool markAuto;

	QColor nLink;
	QColor cLink;
	bool customBack;
	QColor nBack;
	QColor sBack;
	QColor cBack;


	QTabWidget* tabWidget;

	QWidget* conftab;
	QGridLayout* tabLayout;
	QLabel* confLabel;
	QListView* confList;
	enum {
		confLabelRow,
		confListRow,
		ConfRowMax
	};
	enum {
		confMinCol,
		confMaxCol,
		ConfColMax
	};
	char keyMapping[MenuItem::Short_Size];

	QMap<int,int> sizeToIndex;
	
	QWidget* menuTab;
	QGridLayout* menuTabLayout;
	QPushButton* addButton;
	QPushButton* modButton;
	QPushButton* delButton;
	QPushButton* upButton;
	QPushButton* downButton;
	QPushButton* levelButton;
	QListView* menuList;
	enum {
		buttonRow,
		listRow,
		MenuRowMax
	};
	enum {
		addButtonCol,
		modButtonCol,
		delButtonCol,
		upButtonCol,
		downButtonCol,
		levelButtonCol,
		MenuColMax
	};

	QWidget* optTab;
	QGridLayout* optTabLayout;
	QLabel* fileFontLabel;
	QComboBox* fileFontBox;
	QLabel* viewFontLabel;
	QComboBox* viewFontBox;
	QLabel* memoAlterLabel;
	QLineEdit* memoAlterEdit;
	QPushButton* memoAlterButton;
	QLabel* textExtLabel;
	QLineEdit* textExtEdit;
	QLabel* shellExtLabel;
	QLineEdit* shellExtEdit;
	QCheckBox* sudoCheckBox;
	QCheckBox* symmetryBox;
	QCheckBox* markAutoBox;
	QPushButton* optOkButton;
	QPushButton* optCancelButton;

	enum {
		LeftCol,
		MidCol,
		RightCol,
		OptColMax
	};
	enum {
		FileFontRow,
		ViewFontRow,
		MemoAlterRow,
		TextExtRow,
		ShellExtRow,
		SudoRow,
		SymmetryRow,
		MarkAutoRow,
		OkRow,
		OptRowMax
	};

	QWidget* colorTab;
	QGridLayout* colorTabLayout;
	QLabel* redLabel;
	QLabel* greenLabel;
	QLabel* blueLabel;
	QLabel* normalLinkLabel;
	QSpinBox* nlRedBox;
	QSpinBox* nlGreenBox;
	QSpinBox* nlBlueBox;
	QLabel* cardLinkLabel;
	QSpinBox* clRedBox;
	QSpinBox* clGreenBox;
	QSpinBox* clBlueBox;
	QCheckBox* customBox;
	QLabel* normalBackLabel;
	QSpinBox* nbRedBox;
	QSpinBox* nbGreenBox;
	QSpinBox* nbBlueBox;
	QLabel* sdBackLabel;
	QSpinBox* sbRedBox;
	QSpinBox* sbGreenBox;
	QSpinBox* sbBlueBox;
	QLabel* cfBackLabel;
	QSpinBox* cbRedBox;
	QSpinBox* cbGreenBox;
	QSpinBox* cbBlueBox;
	QPushButton* colorOkButton;
	QPushButton* colorCancelButton;

	enum {
		LabelCol,
		RedCol,
		GreenCol,
		BlueCol,
		ColorColMax
	};
	enum {
		LabelRow,
		NormalLinkRow,
		CardLinkRow,
		CustomRow,
		NormalBackRow,
		SdBackRow,
		CfBackRow,
		ColorButtonRow,
		ColorRowMax
	};

	static const char indexToSize[];
};
