#include <qpushbutton.h>
#include <qvbox.h>
#include <qdir.h>
#include <qlineedit.h>
#include <qmessagebox.h>

#include "../shared/FileView.h"
#include "../shared/MiscLib.h"

#include "FileDialog.h"


FileDialog::FileDialog( const QString& path, const QString& mask, QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
	base = new QVBox(this);
	base->resize(QApplication::desktop()->width(),QApplication::desktop()->height()-70);
	fileSelect = new FileView(path, mask,TRUE,FALSE,TRUE, base);
	okButton = new QPushButton(base);
	selectChanged(*(fileSelect->selected()));

	fileSelect->setFocus();

	connect (fileSelect,SIGNAL(selectionChanged(const QFileInfo &)), this, SLOT(selectChanged(const QFileInfo &) ) );
	connect (okButton,SIGNAL(clicked()) , this, SLOT(okPressed()) );

}


/*  
 *  Destroys the object and frees any allocated resources
 */
FileDialog::~FileDialog()
{
    // no need to delete child widgets, Qt does it all for us
}

void FileDialog::selectChanged(const QFileInfo & fi)
{
	if ( ! fi.isDir() ) {
		selectF = fi.filePath();
	} else {
		selectF = QString::null;
	}
	okButton->setText(selectF);
	setCaption(fi.filePath());
}

void FileDialog::okPressed()
{
	accept();
}

const QString FileDialog::selectedFile()
{
	return selectF;
}
