#ifndef COMPAREDIALOG_H
#define COMPAREDIALOG_H

#include <qdialog.h>

class QBoxLayout;
class QCheckBox;
class CompareDialog : public QDialog
{ 
	Q_OBJECT

public:
	CompareDialog(QWidget* parent = 0, const char* name = 0, bool modal = TRUE, WFlags fl = 0 );
	~CompareDialog();

	int cmpOpt();
	enum CmpValue {
		Resident = 1,
		FileNew = 2,
		FileOld = 4,
		FileLarge = 8,
		FileSmall = 16,
		SelDirectory = 128,
		SelFileOnly = 256
	};

protected slots:
	virtual void accept();

private slots:
	void setRes(bool b);
	void setNew(bool b);
	void setOld(bool b);
	void setLarge(bool b);
	void setSmall(bool b);

private:
	QBoxLayout* layout;
	QCheckBox* residentCheck;
	QCheckBox* newCheck;
	QCheckBox* oldCheck;
	QCheckBox* largeCheck;
	QCheckBox* smallCheck;
	QCheckBox* selOnlyCheck;
	QCheckBox* dirCheck;

};

#endif
