#ifndef FLIB_H
#define FLIB_H

#include <qfileinfo.h>

class FLib
{ 
public:

	static bool isVga();
	static bool isViewStyle();
	static int fileType(const QFileInfo& f);
	static QString fileTypeName(int i);
	static QString formatNum(int i , int c);
	static QString fixNum(int i , int c);
	static bool matchFileInfo(const QFileInfo& f1,const QFileInfo& f2);

	enum FileType {
		Directory,
		TextFile,
		HtmlFile,
		IpkgFile,
		ImageFile,
		WordFile,
		ExcelFile,
		LzhFile,
		ZipFile,
		GZipFile,
		PdfFile,
		BinaryFile,
		FileTypeCount
	};

	static const char* ftname[FileTypeCount];

	static const int VgaWidth = 640;
	static const int HalfVgaWidth = 320;
	static const int VgaHeight = 480;
	static const int HalfVgaHeight = 240;
};

#endif
