#include <qcombobox.h>
#include <qpe/config.h>

#include "FLib.h"

#include "FilterDialog.h"

FilterDialog::FilterDialog(QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
	if (FLib::isVga()) {
		resize( 300, 40 );
	} else {
		resize( 150,20);
	}
	setCaption( tr( "Filter" ) );

	filterBox = new QComboBox(this);
	if (FLib::isVga()) {
		filterBox->setGeometry( QRect( 0, 0, 296, 32 ) ); 
	} else {
		filterBox->setGeometry( QRect( 0, 0, 148, 18 ) ); 
	}
	filterBox->setEditable(TRUE);
	filterBox->setDuplicatesEnabled(FALSE);
	filterBox->setAutoCompletion(TRUE);

	Config cf = Config("FileLaunch");
	cf.setGroup("filter");
	for ( int i = 0 ; i < 10 ; ++i ) {
		QString f = cf.readEntry(QString("Filter%1").arg(i)) ;
		if (! f.isEmpty() ) {
			filterBox->insertItem(f);
		}
	}
}

FilterDialog::~FilterDialog()
{
	Config cf = Config("FileLaunch");
	cf.setGroup("filter");
	cf.clearGroup();
	for (int i = 0; i < filterBox->count() ; ++i) {
		cf.writeEntry(QString("Filter%1").arg(i),filterBox->text(i));
	}
}
