#include <qlineedit.h>
#include <qpe/config.h>

#include "FLib.h"

#include "InputDialog.h"

InputDialog::InputDialog(const QString& cap, const QString& msg ,QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
	if (FLib::isVga()) {
		setFont(QFont("lcfont",18));
		resize( 480, 40 );
	} else {
		resize( 220,20);
	}
	setCaption( cap );
	line = new QLineEdit(this);

	if (FLib::isVga()) {
		line->setGeometry( QRect( 0, 0, 476, 32 ) ); 
	} else {
		line->setGeometry( QRect( 0, 0, 198, 18 ) ); 
	}
	line->setText(msg);
	if (msg.length() > 0) {
		line->setSelection(0,msg.length());
	}
	connect ( line ,SIGNAL(returnPressed()) , this, SLOT(accept()) );
}

InputDialog::~InputDialog()
{
}

QString InputDialog::text() const
{
	return line->text();
}
