#ifndef MENUITEM_H
#define MENUITEM_H


#include <qlistview.h>
#include <qstring.h>

class MenuItem
{ 
public:
	MenuItem() ;
	MenuItem(int lev,int t,bool a, const QString& n, const QString& p, const QString& pa, int p1,int p2, const QString& ms, int s, int h);

	~MenuItem();
	int depth(){ return level; };
	int type() { return itemType ;};
	bool autoT() { return autoTitle; };
	QString& name() { return title; };
	QString& pathName() { return path; };
	QString& paramForm() { return param; };
	int p1Type() { return firstParam ; };
	int p2Type() { return secondParam; };
	QString& msgDisp() { return msg; };
	int shortKey() { return sKey; };
	int hotKey() { return hKey; };
	
	void setItems(int lev,int t,bool a, const QString& n, const QString& p, const QString& pa, int p1,int p2,  const QString& ms , int s, int h);

	static QString skeyCode(int i) { return QString(QChar(sCode[i])) ;};
	static int hkeyCode(int i) { return hCode[i] ;};

	static const int reserveItem = 40;

	enum ItemType {
		QtApps,
		ShellW,
		ShellD,
		QCopSend,
		Menu,
	};
	enum ParamType {
		Always,
		DirOnly,
		FileOnly,
		Inputs,
		NotUseParam,
		Inputd ,
		Separate = NotUseParam
	};
	enum ShortKeyCode {
		Short_No,
		Short_0,Short_1,Short_2,Short_3,Short_4,Short_5,Short_6,Short_7,Short_8,Short_9,
		Short_A,Short_B,Short_C,Short_D,Short_E,Short_F,Short_G,Short_H,Short_I,Short_J,
		Short_K,Short_L,Short_M,Short_N,Short_O,Short_P,Short_Q,Short_R,Short_S,Short_T,
		Short_U,Short_V,Short_W,Short_X,Short_Y,Short_Z,Short_DEL,Short_Comma,Short_Minus,
		Short_Size
	};

private:
	int level;
	int itemType;
	bool autoTitle;
	QString title;
	QString path;
	QString param;
	int firstParam;
	int secondParam;
	QString msg;
	int sKey;
	int hKey;

	static const char sCode[];
	static const int hCode[];
};

#endif
