#ifndef PREVIEW_H
#define PREVIEW_H
#include <qvbox.h>
#include <qtextview.h>
#include <qlabel.h>
#include <qfileinfo.h>
#include <qmap.h>

class PreviewBox : public QVBox
{ 
    Q_OBJECT

public:
	PreviewBox(QWidget* parent = 0, const char* name = 0,  WFlags fl = 0 );
	~PreviewBox();
	void setFile(const QFileInfo& f);
	virtual QSize sizeHint() const;
	void setFontSize(int i);
	QString prevFileCode();
	void setSize(int x,int y);
	void loadCfg();
	void setSmooth(bool smoothResize);

protected:
	virtual void resizeEvent(QResizeEvent *e);
	virtual void showEvent(QShowEvent *e);
	virtual void hideEvent(QHideEvent *e);

private:
	void viewFile();
	bool checkFile(const char *buf,int fsize);
	QTextView* textView;
	QLabel* imageView;
	QString codename;
	int sizeX;
	int sizeY;
	QFileInfo viewFileInfo;
	bool loaded;
	bool smooth;

	QMap<QString,QString> set;

	static const int PreviewReadSize = 2000;
	static const int HtmlReadSize = 10000;

	static const char binfile[7];
	static const char gzipfile[3];
	static const char lzhfile[7];
};

#endif
