#ifndef PROCDIALOG_H
#define PROCDIALOG_H

#include <qdialog.h>
#include <qmultilineedit.h>
#include <qpushbutton.h>
#include <qstring.h>
#include <qlayout.h>
#include <qtimer.h>
#include <qtabwidget.h>

#include <signal.h>

#include "View.h"

typedef void Sigfunc(int);

class ProcDialog : public QDialog
{ 
	Q_OBJECT
public:
	ProcDialog(const QString& cmd, const QString&pa , int fontSize ,QWidget* parent = 0, const char* name = 0, bool modal = TRUE, WFlags fl = 0 );
	~ProcDialog();
	void procTerm(int w);
	int child() {return childId; }

protected:
	virtual void showEvent ( QShowEvent * );
	virtual void accept();
	virtual void reject();

private slots:
	void procCheck();
	void pressKill();

private:
	static const int PIPEBUF = 500;
	static const int ProcCheckInterval = 200;

	void procStart();
	void readPipe(int t,bool last);
	enum {
		ReadOut,
		ReadErr
	};
	bool checkPipe(int t);

	QGridLayout* layout;
	QTabWidget* tab;
	View* view;
//	View* errView;
	QPushButton* sel;
	QPushButton* can;
	QPushButton* cp;

	QString cmdName;
	QString param;
	bool useShell;
	int stdOut[2];
	int stdErr[2];
	int childId;
	QTimer* timer;
	bool termEntered;
	bool termed;
	int result;
	QCString lastStr[2];

	Sigfunc* defChildHandler;

};

#endif
