#include <stdio.h>

#include <qfileinfo.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qstring.h>
#include <qstringlist.h>
#include <qtextcodec.h>
#include <qpe/config.h>

#include "fladd.h"
#include "../FileLaunch/Flib.h"

FlAdd::FlAdd(const char* filename)
{


	QFileInfo fi(filename);
	if (! fi.exists()) {
		printf("%s not resident",filename);
		exit(127);
	}

	QFile f(filename);
	if ( f.open(IO_ReadOnly)) {
		QTextCodec* codec = QTextCodec::codecForName("utf8");
		QTextStream t( &f );
		t.setCodec(codec);
		QString txt = t.read();
		f.close();
		QStringList itemList = getItem(txt);
		addItem(itemList);
	} else {
		printf("%s open error",filename);
		exit(127);
	}
}

FlAdd::~FlAdd()
{
}

QStringList FlAdd::getItem(const QString& txt)
{
	QStringList in = QStringList::split('\n',txt);
	QStringList out;
	for ( QStringList::Iterator it = in.begin(); it != in.end(); ++it ) {
		(*it).replace(QRegExp("^Item_[0-9][0-9][0-9] ="),"");
		out.append(*it);
	}
	return out;
}

void FlAdd::addItem(const QStringList& item)
{
	Config cf(ConfigName);
	cf.setGroup("menu");
	int i = 0;
	while ( cf.hasKey("Item_" + FLib::fixNum(i,3) ) ) {
		++i;
	}
	int j = i;
	for ( QStringList::ConstIterator it = item.begin(); it != item.end(); ++it ) {
		cf.writeEntry("Item_"+FLib::fixNum(i,3),(*it));
		++i;
	}
	printf ("add %d items \n",i -j );
}

const char FlAdd::ConfigName[] = { "FileLaunch" };
